<?php
class ControllerExtensionTotalServiceCharge extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/total/service_charge');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('total_service_charge', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=total', true));
		}

		$data['heading_title'] = $this->language->get('heading_title');
		
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');

		$data['entry_text_service'] = $this->language->get('entry_text_service');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['entry_min_price'] = $this->language->get('entry_min_price');
		$data['entry_max_price'] = $this->language->get('entry_max_price');
		$data['entry_charge'] = $this->language->get('entry_charge');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['button_rule_add'] = $this->language->get('button_rule_add');
		$data['button_remove'] = $this->language->get('button_remove');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=total', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/total/service_charge', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['action'] = $this->url->link('extension/total/service_charge', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token']. '&type=total', true);

		if (isset($this->request->post['total_service_charge_text_service'])) {
			$data['total_service_charge_text_service'] = $this->request->post['total_service_charge_text_service'];
		} else {
			$data['total_service_charge_text_service'] = $this->config->get('total_service_charge_text_service');
		}
		
		if (isset($this->request->post['total_service_charge_status'])) {
			$data['total_service_charge_status'] = $this->request->post['total_service_charge_status'];
		} else {
			$data['total_service_charge_status'] = $this->config->get('total_service_charge_status');
		}

		if (isset($this->request->post['total_service_charge_sort_order'])) {
			$data['total_service_charge_sort_order'] = $this->request->post['total_service_charge_sort_order'];
		} else {
			$data['total_service_charge_sort_order'] = $this->config->get('total_service_charge_sort_order');
		}



		if (isset($this->request->post['total_service_charge_rule'])) {
			$data['total_service_charge_rules'] = $this->request->post['total_service_charge_rule'];
		} elseif (!trim(serialize($this->config->get('total_service_charge_rule')))== false) {
			$data['total_service_charge_rules'] = $this->config->get('total_service_charge_rule');
		} else {
			$data['total_service_charge_rules'] = array();
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/total/service_charge', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/total/service_charge')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
}